#include "albero.h"


int analizza_frequenze(struct bitio *b,struct nodo* albero){
	char byte=0;
	int i=0;
	

	for(i=0;i<513;i++){
	     albero[i].frequenza=0;
	     albero[i].lung_codifica=0;
		 albero[i].padre=albero[i].sinistro=albero[i].destro=-1;
	}

	while(bit_read(b,&byte,8)>0)
	  (albero[(unsigned char)byte]).frequenza++;
	
	albero[256].frequenza = 1;

	lseek(b->fd,0,SEEK_SET);
	
	return 1;
}


int genera_albero(struct nodo* albero){

	int i = 0, range = 257;
	int sx = 0, dx = 0;
	int tag[513];

	for(i=0; i<513; i++)
		tag[i] = 0;

	for(i=0; i<256; i++, range++){
		sx = seleziona_minimo(albero, tag, range);
		tag[sx] = 1;
		dx = seleziona_minimo(albero, tag, range);
		tag[dx] = 1;

		albero[range].frequenza = albero[sx].frequenza + albero[dx].frequenza;

		albero[range].destro = dx;
		albero[range].sinistro = sx;

		albero[sx].padre = range;
		albero[dx].padre = range;

	}
	return 1;

}


int seleziona_minimo(struct nodo *albero, int *tag, int range){
	
	int i = 0, minimo = 0 , pos = 0;

	while((i<range) && (tag[i] == 1))
		i++;
	minimo = albero[i].frequenza;
	pos = i;


	for(i; i<range; i++){
		if((tag[i] == 0) && (albero[i].frequenza)<minimo){
			minimo = albero[i].frequenza;
			pos = i;
		}
	}

	return pos;
}


int codifica(struct nodo *albero){

	int i=0, j=0, pos=0;

	for(i=0; i<257; i++){
		j = 0;
		pos = i;
		while(albero[pos].padre!=-1){
			if(albero[albero[pos].padre].sinistro == pos)
				albero[i].codifica[j] = 0;
			else albero[i].codifica[j] = 1;
			j++;
			pos = albero[pos].padre;
		}

		albero[i].lung_codifica = j;

	}
	return 1;
}

int comprimi(char* from,char* to){
	
	struct bitio *r=0,*w=0;
	struct nodo albero[513];
	char buffer=0;
	int i=0;

	r = bit_open(from,O_RDONLY,S_IREAD);
    w = bit_open(to,O_WRONLY|O_CREAT,_S_IREAD | _S_IWRITE);

 
 if(r!=NULL)
 {
	 if(w!=NULL)
		{
			analizza_frequenze(r,albero);
			genera_albero(albero);
			codifica(albero);
			salva_tabella(albero,w);

			while(bit_read(r,&buffer,8)>0)
			{
				for(i=0;i<albero[(unsigned char)buffer].lung_codifica;i++)
					bit_write(w,(unsigned char*)&albero[(unsigned char)buffer].codifica[albero[(unsigned char)buffer].lung_codifica-i-1],1);	//forse scrittura rovesciata
			}
			
			for(i=0;i<albero[256].lung_codifica;i++)
					bit_write(w,(unsigned char*)&albero[256].codifica[albero[256].lung_codifica-i-1],1);	

			bit_close(w);
		}
	 else printf("UNABLE TO OPEN OUTPUT FILE\n");
	 bit_close(r);
	 return 1;
 }
 else 
 {
	 printf("UNABLE TO OPEN INPUT FILE\n");
	 return -1;
 }
	
}



int salva_tabella(struct nodo *albero, struct bitio *w){
	int i = 0;

	if(w!=NULL){
		for(i=0;i<257;i++)
			bit_write(w,(char*)&albero[i].frequenza,sizeof(long int)*8);		

	
		return 1;
	}

	return -1;

}


int decomprimi(char *from, char *to){
	
	struct bitio *r=0,*w=0;
	struct nodo albero[513];
	char buffer=0;
	int i=0;
	int ris = 0;
	int pos = 512;
	int flag = 1;

	r = bit_open(from,O_RDONLY,S_IREAD);
    w = bit_open(to,O_WRONLY|O_CREAT,_S_IREAD | _S_IWRITE);

 
 if(r!=NULL)
 {
	 if(w!=NULL){
			
	 		for(i=0;i<513;i++){
				albero[i].frequenza=0;
				albero[i].lung_codifica=0;
				albero[i].padre=albero[i].sinistro=albero[i].destro=-1;
			}
			carica_tabella(albero,r);
			genera_albero(albero);
			
			while((ris = bit_read(r,&buffer,1)>0)&&flag){
				if(buffer==1)
					pos=albero[pos].destro;
				else pos=albero[pos].sinistro;
				if(albero[pos].sinistro==-1 && albero[pos].destro==-1){
					
					if(pos<256){
						unsigned char temp = (unsigned char)pos;
						bit_write(w,&temp,8);
						pos = 512;
					}
					else flag=0;
				}

			}
		    bit_close(w);	
	 }
	 bit_close(r);
 }


 if(ris==-1)
	 return -1;

 return 1;
}


int carica_tabella(struct nodo *albero, struct bitio *r){
	int i = 0;

	if(r!=NULL){
		for(i=0;i<257;i++)
			bit_read(r,(char*)&albero[i].frequenza,sizeof(long int)*8);		

		return 1;
	}

	return -1;
}