#include "bitio.h"

extern int bytescr;

struct bitio* bit_open(char* nome,int modo,int diritti){
	struct bitio* bi;
	int i=0;

	bi=(struct bitio*) malloc(sizeof(struct bitio));
	
	if(bi==NULL)
		return bi;

	if(modo!= O_RDONLY && modo != O_WRONLY && modo!=(O_WRONLY|O_CREAT)){
		free(bi);
		return NULL; 
	}
				

	bi->modo=modo;

	bi->fd=open(nome,modo,diritti);
	if(bi->fd<0){
		free(bi);
		return NULL;
	}	

	bi->last=0;
	bi->first=0;

	for(i=0;i<MAX;i++)
		bi->bitbuffer[i]=0;

	return bi;

}



int bit_close(struct bitio* bi){
  int ris=0;

  bit_flush(bi);

  ris=close(bi->fd);
  if(ris!=0)
     return -1;
  
  free(bi);
  return 0;

}




int bit_read(struct bitio* b,char* buffer,int lung){
	int byteletti = 1;
	int i = 0, bit = 0, shift = 0;
    char c = 0;



	if(b->first==b->last) 
		byteletti = load_buffer(b);
	
	if(byteletti==-1)
	    return -1;

	for(i=0; (i<lung)&&(byteletti>0); i++){
			c = b->bitbuffer[(b->first)/8];  		
	        shift = (b->first)%8;
			bit = (c>>shift)&1;
			

			if(bit == 1)
				buffer[i/8] |= (1<<(i%8));
			else
				buffer[i/8] &= ~(1<<(i%8));
			(b->first)++;
			if(b->first==b->last) 
		                byteletti = load_buffer(b);

			
	}			
	return i; 
}



int load_buffer(struct bitio* b){ 
	int byteletti=0;
		
        byteletti=read(b->fd,b->bitbuffer,MAX);

       	if(byteletti==-1)
              {
		b->first=b->last;
		return -1;
	      }
        else{
	     b->first=0;
             b->last=byteletti*8;
        }

	return byteletti;
}


int bit_write(struct bitio* b,char* buffer, int lung)
{
	int bytescritti=1,i=0,shift=0,bit=0;
	char c=0;

	if((b->last/8)==MAX)
		bytescritti=write_buffer(b);

	if(bytescritti==-1)
		return -1;

	 for(i=0; (i<lung)&&(bytescritti>0); i++){
                        c = buffer[i/8];    
                        shift = b->last%8;
                        bit = (c>>(i%8))&1;
		
                        if(bit == 1)
                                b->bitbuffer[b->last/8] |= (1<<shift);
                        else
                                b->bitbuffer[b->last/8] &= ~(1<<shift);
                        

                      
			(b->last)++;
			if((b->last)/8==MAX) 
                 bytescritti = write_buffer(b);


        }
 return i;
}

int bit_flush(struct bitio* b)
{
	return write_buffer(b);
}

int write_buffer(struct bitio* b)
{
	int bytescritti=0;
	int bytes = (b->last)/8;

	if((b->last%8))
		bytes++;

	if(b->last>0){
 	   bytescritti=write(b->fd,b->bitbuffer,bytes);
       b->first=b->last=0;
	}
	return bytescritti;
}

